Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
Remove temporary files.
[simgrid.git] / src / smpi / smpiff.in
index feb4563..9e78970 100644 (file)
@@ -1,63 +1,63 @@
 #! /bin/sh
-prefix="@exec_prefix@"
-
-ARGS="-DMAIN__=user_main -Diargc_=smpi_process_argc -Dgetarg_=smpi_process_getarg"
-LINKARGS="-L@F2C_LIBRARY_PATH@ -lf2c -lm"
-# $1: prefix, $2: suffix
-mymktemp () {
-    tmp=$(mktemp --suffix="$2" "$1_XXXXXXXXXX" 2> /dev/null)
-    if [ -z "$tmp" ]; then
-        # mktemp failed (unsupported --suffix ?), try unsafe mode
-        tmp=$(mktemp -u "$1_XXXXXXXXXX" 2> /dev/null)
-        if [ -z "$tmp" ]; then
-            # mktemp failed again (doesn't exist ?), try very unsafe mode
-            tmp="$1_$$x$RANDOM"
-        fi
-        tmp="${tmp}$2"
-        # create temp file, and exit if it existed before
-        sh -C -c "true > \"${tmp}\"" || exit 1
-    fi
-    echo "${tmp}"
+
+# Copyright (c) 2012-2014. The SimGrid Team.
+# All rights reserved.
+
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the license (GNU LGPL) which comes with this package.
+
+SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
+
+F77=@GFORTRAN_EXE@
+
+INCLUDEARGS="@includeflag@"
+CMAKE_LINKARGS="-L@libdir@"
+
+@SMPITOOLS_SH@
+
+list_set FFLAGS "-ff2c" "-fno-second-underscore"
+list_set LINKARGS "-lsimgrid" "-lm" "-lgfortran"
+list_set TMPFILES
+main_name=main
+
+cleanup () {
+    eval $(list_get TMPFILES)
+    rm -f "$@"
 }
+trap 'cleanup' EXIT
 
-SRCFILES=""
-while [ -n "$1" ]; do
-  ARG="$1"
-  shift
-  case "${ARG}" in
-    *.f)
-      SRCFILE="$(readlink -f ${ARG} 2>/dev/null)"
-       if [ -z "$SRCFILE" ] ; then
-         SRCFILE="$ARG"
-       fi
-       SRCFILES="${SRCFILES} ${SRCFILE}"
-       ;;
-    *)
-      if [ "${ARG}" = "-c" ]; then
-          LINKARGS=""
-      fi
-      ARGS="${ARGS} ${ARG}"
-      ;;
-  esac
+list_set CMDLINE "${F77}"
+list_add_not_empty CMDLINE "${FFLAGS}"
+while [ $# -gt 0 ]; do
+    ARG="$1"
+    shift
+    case "${ARG}" in
+        -c)
+            CMAKE_LINKARGS=""
+            LINKARGS=""
+            list_add CMDLINE "-c"
+            ;;
+        *.f|*.F)
+            TMPFILE=$(mymktemp "${ARG}" ".f")
+            list_add TMPFILES "${TMPFILE}"
+      #replace "program main_name by subroutine user\_main (and the end clause as well)"
+            sed 's/[[:space:]]\{6\}[[:space:]]*\(end \)\{0,1\}program[[:space:]]*\([a-zA-Z0-9\-\_]*\)/      \1subroutine user_main /gI;s/[[:space:]]*use[[:space:]]*mpi/\include \"mpif\.h\" /gI' "${ARG}" > "${TMPFILE}"
+            SRCFILE="${TMPFILE}"
+            list_add CMDLINE "${SRCFILE}"
+            ;;
+        '-version' | '--version' | '-v')
+            printf '%b\n' "$SIMGRID_VERSION"
+            exit 0
+            ;;           
+        *)
+            list_add CMDLINE "${ARG}"
+            ;;
+    esac
 done
-ARGS="${ARGS} ${LINKARGS}"
-
-if [ -n "${SRCFILES}" ]
-then
-   for SRCFILE in ${SRCFILES}
-   do
-      TMPFILE=$(mymktemp "${SRCFILE}" ".f")
-      cp ${SRCFILE} ${TMPFILE}
-      CFILE="${TMPFILE%.f}.c"
-      #echo "$prefix/bin/smpif2c ${TMPFILE} && $prefix/bin/smpicc ${ARGS} ${CFILE} && rm ${CFILE} && rm ${TMPFILE}"
-      $prefix/bin/smpif2c ${TMPFILE} && $prefix/bin/smpicc ${ARGS} ${CFILE} && rm ${CFILE} && rm ${TMPFILE} || exit $?
-      # When the file is compiled with "-c" and no output file is specified with
-      # "-o", rename the output.  FIXME: do it properly.
-      if [ -f ${CFILE%.c}.o ]; then
-          mv ${CFILE%.c}.o ${SRCFILE%.f}.o
-      fi
-   done
-else
-   #echo "$prefix/bin/smpicc ${ARGS}"
-   $prefix/bin/smpicc ${ARGS}
-fi
+
+list_add_not_empty CMDLINE ${INCLUDEARGS}
+list_add_not_empty CMDLINE ${CMAKE_LINKARGS}
+list_add_not_empty CMDLINE "${LINKARGS}"
+
+eval $(list_get CMDLINE)
+"$@"